function Create(self)
	if self.PresetName == "Dispenser L" then
		self.grabbox = Box(Vector(self.Pos.X - 40,self.Pos.Y - 37),Vector(self.Pos.X + 15,self.Pos.Y - 23));
		self.checkbox = Box(Vector(self.Pos.X - 60,self.Pos.Y - 36),Vector(self.Pos.X + 36,self.Pos.Y + 60));
		self.hdspawnpos = Vector(self.Pos.X + 28,self.Pos.Y);
		self.hdspawnvel = Vector(4,0);
		self.tdspawnpos = Vector(self.Pos.X + 30,self.Pos.Y + 20);
		self.tdspawnvel = Vector(6,-3);
		self.barpos = Vector(self.Pos.X - 12,self.Pos.Y - 28);
	else
		self.grabbox = Box(Vector(self.Pos.X + 40,self.Pos.Y - 37),Vector(self.Pos.X + 15,self.Pos.Y - 23));
		self.checkbox = Box(Vector(self.Pos.X - 36,self.Pos.Y - 36),Vector(self.Pos.X + 60,self.Pos.Y + 60));
		self.hdspawnpos = Vector(self.Pos.X - 28,self.Pos.Y);
		self.hdspawnvel = Vector(-4,0);
		self.tdspawnpos = Vector(self.Pos.X - 30,self.Pos.Y + 20);
		self.tdspawnvel = Vector(-6,-3);
		self.barpos = Vector(self.Pos.X + 12,self.Pos.Y - 28);
	end

	self.checktimer = Timer();
	self.checktimer2 = Timer();
	self.buildtimer = Timer();
	self.bartimer = Timer();
	self.checkontimer = Timer();

	self.item = nil;
	self.class = nil;
	self.builditem = nil;
	self.hasitem = 0;
	self.cost = 0;
	self.interval = 0;
	self.on = 1;
	self.hasactor = 0;
	self.wegothim = 0;
	self.toanimate = 1;

	self.RotAngle = 0;
	
	self.bar = CreateMOSRotating("Progress Bar");
	self.bar.Pos = self.barpos;
	MovableMan:AddParticle(self.bar);
	function self.progressbar()
		if MovableMan:IsParticle(self.bar) == true then
			self.bar.ToSettle = false;
			self.bar.ToDelete = false;
			if self.on == 1 then
				if self.bartimer:IsPastSimMS(self.interval) == true then
					self.bar.Frame = 5;
					self.bartimer:Reset();
				elseif self.interval == 0 then
					self.bar.Frame = 5;
				elseif self.bartimer:IsPastSimMS(self.interval / 5 * 4) then
					self.bar.Frame = 4;
				elseif self.bartimer:IsPastSimMS(self.interval / 5 * 3) then
					self.bar.Frame = 3;
				elseif self.bartimer:IsPastSimMS(self.interval / 5 * 2) then
					self.bar.Frame = 2;
				elseif self.bartimer:IsPastSimMS(self.interval / 5 * 1) then
					self.bar.Frame = 1;
				else
					self.bar.Frame = 0;
				end
			elseif self.on == 0 then
				self.bar.Frame = 0;
			end
		else
			self.bar = CreateMOSRotating("Progress Bar");
			self.bar.Pos = self.barpos;
			MovableMan:AddParticle(self.bar);
		end
	end

	function self.getitem()
		if self.checktimer:IsPastSimMS(50) == true then
			for item in MovableMan.Items do
				if self.grabbox:WithinBox(item.Pos) == true then
					if item.PresetName ~= self.item then
						item.ToDelete = true;
						self.item = item.PresetName;
						self.class = item.ClassName;
						if self.hasitem == 0 then
							self.hasitem = 1;
							if item.ClassName == "HDFirearm" or item.ClassName == "HeldDevice" then
								self.interval = 3000 + item.Mass * 50;
								self.cost = item.GoldValue;
							elseif item.ClassName == "TDExplosive" then
								self.interval = 2000 + item.Mass * 100;
								self.cost = item.GoldValue;
							end
						end
					else
						if self.hasitem == 1 then
							if item.ClassName == "HDFirearm" or item.ClassName == "HeldDevice" then
								self.interval = 3000 + item.Mass * 50;
								self.cost = item.GoldValue;
							elseif item.ClassName == "TDExplosive" then
								self.interval = 2000 + item.Mass * 100;
								self.cost = item.GoldValue;
							end
						end
					end
				end
			end
		end
	end
	
	function self.spawnitem(item)
		if item ~= nil and self.on == 1 then
			local goldcount = ActivityMan:GetActivity():GetTeamFunds(self.Team);
			if self.buildtimer:IsPastSimMS(self.interval) == true and goldcount > self.cost then
				self.buildtimer:Reset();
				if self.class == "TDExplosive" then
					self.builditem = CreateTDExplosive(item);
					self.builditem.Vel = self.tdspawnvel;
					self.builditem.Pos = self.tdspawnpos;
				elseif self.class == "HDFirearm" then
					self.builditem = CreateHDFirearm(item);
					self.builditem.Vel = self.hdspawnvel;
					self.builditem.Pos = self.hdspawnpos;
				else
					self.builditem = CreateHeldDevice(item);
					self.builditem.Vel = self.hdspawnvel;
					self.builditem.Pos = self.hdspawnpos;
				end
				MovableMan:AddItem(self.builditem);
				ActivityMan:GetActivity():SetTeamFunds(goldcount - self.cost,self.Team);
			end
		else
			self.buildtimer:Reset();
			self.bartimer:Reset();
		end
	end
	
	function self.toggle()
		if self.checktimer2:IsPastSimMS(50) == true and self.hasactor == 0 then
			self.checktimer2:Reset();
			for actor in MovableMan.Actors do
				if self.checkbox:WithinBox(actor.Pos) == true then
					self.hasactor = 1;
					break;
				elseif self.checkbox:WithinBox(actor.Pos) == false then
					self.hasactor = 0;
				end
			end
		end
		if self.checkontimer:IsPastSimMS(5000) == true and self.hasactor == 1 then
			for actor in MovableMan.Actors do
				if self.checkbox:WithinBox(actor.Pos) == true then
					self.checkontimer:Reset();
					self.wegothim = 1;
					local hasflipped = 0;
					if self.on == 1 and hasflipped == 0 then
						self.on = 0;
						local hasflipped = 1;
					elseif hasflipped == 0 then
						self.on = 1;
						local hasflipped = 1;
					end
					break;
				else
					self.hasactor = 0;
					self.checkontimer:Reset();
				end
			end
		end
		if self.hasactor == 0 then
			self.checkontimer:Reset();
		end
	end
end

function Update(self)
	self.getitem();
	self.spawnitem(self.item);
	self.progressbar();
	self.toggle();

	self.ToDelete = false;
	self.ToSettle = false;
	self.RotAngle = 0;
	self.Vel = Vector(0,0);
end